//code copied from JSFF (bug 413380) with a few modifications made to preserve data length. data length can theoretically be changed if i take to time to update length indicator values according to the spec. maybe later

var unicodeOdds = 4; //when creating a text block for insertion, 1/unicodeOdds of the time it will contain alternating nulls

function fillString(chr,len,uni){
  var r="";
  for(var i=0;i<(uni?Math.floor(len/2):len);i++)
    r+=(uni?"\x00":"") + chr;
  return r;
}

function rnd(max)
{
  return rand_max(max);
}

function rndElt(a)
{ 
  if (typeof a == "string")
    dumpln("String passed to rndElt: " + a);
    
  if (typeof a == "function")
    dumpln("Function passed to rndElt: " + a);

  if (a == null)
    dumpln("Null passed to rndElt");
  
  if (!a.length) {
    dumpln("Empty thing passed to rndElt");
    return null;
  }
    
  return a[rnd(a.length)]; 
}

function insertAlternatingNulls(val){
  //injects nulls into val, replacing every other byte (starting with index 0). for simulating unicode
  var retVal="";
  for(var i=1;i<val.length;i+=2)
    retVal += "\0" + val[i];
  if(retVal.length<val.length)
    retVal += "\0";
  return retVal;
}

function rndChr(uni){
  //if(uni && rnd(2))
  //	return String.fromCharCode(rnd(0xffff) + 1);
  return String.fromCharCode(rnd(0xff) + 1);
}

function moveBlock(val, operation){
  //depending on operation:
  //	0. moves a block of data to another area of val, deleting the old block instance
  //	1. overwrites data in original val with a block of code in val
  var strt = rnd(val.length);
  //higher chance of moving less characters, with a seperate case for moving very small blocks
  var end = strt + (rnd(3) ? rnd(val.length - strt) : rnd(4)) + 1;
  
  if (end >= val.length) end = val.length;
  var dataWithoutBlock = val.substring(0,strt) + val.substring(end,val.length);
  var moveBlockTo;
  switch(operation){
    case 0:
      moveBlockTo = rnd(dataWithoutBlock.length);
      
      retVal = dataWithoutBlock.substring(0,moveBlockTo);
      retVal += val.substring(strt, end);
      retVal += dataWithoutBlock.substring(moveBlockTo, dataWithoutBlock.length);
      break;
    case 1:
      moveBlockTo = rnd(val.length);
      
      retVal = val.substring(0,moveBlockTo);
      retVal += val.substring(strt,end);
      if (retVal.length < val.length)
        retVal += val.substring(retVal.length);
      break;
  }
  
  if(retVal.length != val.length)
    debugger;
  return retVal;
}

function replaceConstantBlock(val){
  
  //inserts a random-sized block of the same character into a random position of val, overwriting old data
  var retVal = val;
  var strt = rnd(retVal.length);
  //higher chance of replacing less characters, with a seperate case for replacing very small blocks
  var end = strt + (rnd(3) ? rnd(retVal.length - strt) : rnd(4)) + 1;
  //make sure we don't go overboard
  if(end > val.length) end = val.length;
  var tempBuff;
  retVal = val.substring(0,strt);
  switch(rnd(5)){
    case 0: case 1: case 2:
      tempBuff = fillString(rndChr(1), end - strt);
      if(!rnd(unicodeOdds)) //make string into unicode
        tempBuff = insertAlternatingNulls(tempBuff);
      retVal += tempBuff;
      break;
    case 3:
      tempBuff = fillString("\xFF", end - strt);
      if(!rnd(unicodeOdds)) //make string into unicode
        tempBuff = insertAlternatingNulls(tempBuff);
      retVal += tempBuff;
      break;
    case 4:
      tempBuff = fillString("\0", end - strt);
      if(!rnd(unicodeOdds)) //make string into unicode
        tempBuff = insertAlternatingNulls(tempBuff);
      retVal += tempBuff;
      break;
  }
  if (retVal.length<val.length)
    retVal += val.substring(end);
    
  return retVal;
}

function replaceRandomBlock(val){
  //inserts a random-sized block of the same character into a random position of val, overwriting old data
  var retVal = val;
  var strt = rnd(val.length);
  //higher chance of replacing less characters, with a seperate case for replacing very small blocks
  var end = strt + (rnd(3) ? rnd(retVal.length - strt) : rnd(4)) + 1;
  //make sure we don't go overboard
  if(end > val.length) end = val.length;
  
  retVal = val.substring(0,strt);
  var tempBuff = "";
  
  for(var i=strt;i<end;i++)
    tempBuff += rndChr(1);
    
  if(!rnd(unicodeOdds)) //make string into unicode
    tempBuff = insertAlternatingNulls(tempBuff);
    
  retVal += tempBuff;
  
    
  if (retVal.length<val.length)
    retVal += val.substring(end);
    
  return retVal;
}

function fuzzContents(contents){
  var maxIterations = 10;
  var retContents = contents;
  
  for(var i=0;i<=rnd(maxIterations);i++)
    switch(rnd(7)){
      case 2:
        retContents = replaceRandomBlock(retContents);
        break;
      case 3:
        retContents = replaceConstantBlock(retContents);
        break;
      case 6:
        retContents = moveBlock(retContents, 0);
        break;
      case 7:
        retContents = moveBlock(retContents, 1);
        break;
    }
    
  return retContents;
}
